; #########################################################################

.const
DECIMAL	STRUCT
	wReserved WORD ?
	union
	STRUCT
		scale BYTE ?
		sign BYTE ?
	ENDS	;struct
		signscale WORD ?		;
	ENDS  ;union
	
	Hi32 DWORD ?	;+12
	union
	STRUCT
IFDEF _MAC
	Mid32 DWORD ?
	Lo32 DWORD ?
	ELSE
	Lo32 DWORD ?
	Mid32 DWORD ?
ENDIF 
	ENDS
	Lo64 QWORD ?
	ENDS
DECIMAL		ENDS



;/* VARIANT STRUCTURE
; *
; *  VARTYPE vt;
; *  WORD wReserved1;
; *  WORD wReserved2;
; *  WORD wReserved3;
; *  union {
; *    LONGLONG       VT_I8
; *    LONG           VT_I4
; *    BYTE           VT_UI1
; *    SHORT          VT_I2
; *    FLOAT          VT_R4
; *    DOUBLE         VT_R8
; *    VARIANT_BOOL   VT_BOOL
; *    SCODE          VT_ERROR
; *    CY             VT_CY
; *    DATE           VT_DATE
; *    BSTR           VT_BSTR
; *    IUnknown *     VT_UNKNOWN
; *    IDispatch *    VT_DISPATCH
; *    SAFEARRAY *    VT_ARRAY
; *    BYTE *         VT_BYREF|VT_UI1
; *    SHORT *        VT_BYREF|VT_I2
; *    LONG *         VT_BYREF|VT_I4
; *    LONGLONG *     VT_BYREF|VT_I8
; *    FLOAT *        VT_BYREF|VT_R4
; *    DOUBLE *       VT_BYREF|VT_R8
; *    VARIANT_BOOL * VT_BYREF|VT_BOOL
; *    SCODE *        VT_BYREF|VT_ERROR
; *    CY *           VT_BYREF|VT_CY
; *    DATE *         VT_BYREF|VT_DATE
; *    BSTR *         VT_BYREF|VT_BSTR
; *    IUnknown **    VT_BYREF|VT_UNKNOWN
; *    IDispatch **   VT_BYREF|VT_DISPATCH
; *    SAFEARRAY **   VT_BYREF|VT_ARRAY
; *    VARIANT *      VT_BYREF|VT_VARIANT
; *    PVOID          VT_BYREF (Generic ByRef)
; *    CHAR           VT_I1
; *    USHORT         VT_UI2
; *    ULONG          VT_UI4
; *    ULONGLONG      VT_UI8
; *    INT            VT_INT
; *    UINT           VT_UINT
; *    DECIMAL *      VT_BYREF|VT_DECIMAL
; *    CHAR *         VT_BYREF|VT_I1
; *    USHORT *       VT_BYREF|VT_UI2
; *    ULONG *        VT_BYREF|VT_UI4
; *    ULONGLONG *    VT_BYREF|VT_UI8
; *    INT *          VT_BYREF|VT_INT
; *    UINT *         VT_BYREF|VT_UINT
; *  }
; */
IF ( __STDC__ AND  NOTDEFINED(_FORCENAMELESSUNION)) OR DEFINED(NONAMELESSUNION) OR ( NOTDEFINED(_MSC_EXTENSIONS) AND  NOTDEFINED(_FORCENAMELESSUNION))
;__VARIANT_NAME_1	equ	< n1>
;__VARIANT_NAME_2	equ	< n2>
;__VARIANT_NAME_3	equ	< n3>
;__VARIANT_NAME_4	equ	< brecVal>
ELSE
__tagVARIANT	equ	
__VARIANT_NAME_1	equ	
__VARIANT_NAME_2	equ	
__VARIANT_NAME_3	equ	
__tagBRECORD	equ	
__VARIANT_NAME_4	equ	
ENDIF 
	__VARIANT_NAME_4 STRUCT	
	pvRecord DWORD ?
	pRecInfo DWORD ?		;IRecordInfo 
	__VARIANT_NAME_4 ENDS
	__VARIANT_NAME_3 union	
	llVal QWORD ?
	lVal DWORD ?
	bVal BYTE ?
	iVal WORD ?
	fltVal REAL4 ?
	dblVal REAL8 ?
	boolVal WORD ?
	bool WORD ?
	scode DWORD ?
	cyVal CY <> 
	date QWORD ?
	bstrVal DWORD ?
	punkVal DWORD ?
	pdispVal DWORD ?
	parray DWORD ?
	pbVal DWORD ?
	piVal DWORD ?
	plVal DWORD ?
	pllVal DWORD ?
	pfltVal DWORD ?
	pdblVal DWORD ?
	pboolVal DWORD ?
	pbool DWORD ?
	pscode DWORD ?
	pcyVal DWORD ?
	pdate DWORD ?
	pbstrVal DWORD ?
	ppunkVal DWORD ?
	ppdispVal DWORD ?
	pparray DWORD ?
	pvarVal DWORD ?
	byref DWORD ?
	cVal BYTE ?
	uiVal WORD ?
	ulVal DWORD ?
	ullVal QWORD ?
	intVal DWORD ?
	uintVal DWORD ?
	pdecVal DWORD ?
	pcVal DWORD ?
	puiVal DWORD ?
	pulVal DWORD ?
	pullVal DWORD ?
	pintVal DWORD ?
	puintVal DWORD ?
	brecVal __VARIANT_NAME_4 <>
	__VARIANT_NAME_3 ENDS
	
	__VARIANT_NAME_2 STRUCT
	vt WORD ?
	wReserved1 WORD ?
	wReserved2 WORD ?
	wReserved3 WORD ?
	n3 __VARIANT_NAME_3 <>
	__VARIANT_NAME_2 ENDS
	
	__VARIANT_NAME_1 union	
	n2 __VARIANT_NAME_2 <>
	decVal DECIMAL <> ;scale
	__VARIANT_NAME_1 ENDS
	

VARIANT	STRUCT
	n1 __VARIANT_NAME_1 <>
VARIANT		ENDS

CreateBstr PROTO :DWORD
UtoA	PROTO :DWORD
AtoU	PROTO :DWORD	
InitVariant PROTO  :DWORD,  :DWORD,  :DWORD 
CreateSingleBstr PROTO  :DWORD 

	BSTR MACRO arg
		invoke CreateBstr,SADR(arg)
		EXITM<eax>
	ENDM

	
   .data	
bstr_array dd 50 dup (0)
buffer db MAX_PATH dup (0)
ubuffer dw MAX_PATH dup (0)
    .code

;################################################################
UtoA PROC  pChain:DWORD 
	invoke WideCharToMultiByte,CP_ACP,NULL,pChain,\
		-1,addr buffer,LENGTHOF buffer,NULL,NULL
	.if eax != 0
		mov edx,eax
		lea eax,buffer
	.endif		  		
         ret
UtoA endp

;################################################################

AtoU PROC  pChain:DWORD 
	invoke MultiByteToWideChar,CP_ACP,NULL,pChain,\
		-1,addr ubuffer,LENGTHOF ubuffer
	.if eax != 0
		mov edx,eax
		lea eax,ubuffer
	.endif		  
         ret
AtoU endp


;################################################################
CreateSingleBstr PROC  pChain:DWORD 
			Local  retour:DWORD
			Local   phrase[MAX_PATH]:WORD 
	invoke MultiByteToWideChar,CP_ACP,NULL,pChain,\
		-1,addr phrase,LENGTHOF phrase  
	invoke SysAllocString,addr phrase
	mov retour,eax	

 FindeCreateSingleBstr:
         mov eax,retour
         ret
CreateSingleBstr endp

;################################################################


;################################################################
;use bstr_array in data
CreateBstr PROC  pChain:DWORD  
			Local  retour:DWORD
			Local   phrase[MAX_PATH]:WORD 
	mov eax,pChain
	invoke MultiByteToWideChar,CP_ACP,NULL,pChain,\
		-1,addr phrase,LENGTHOF phrase  
	invoke SysAllocString,addr phrase
	mov retour,eax	
	.if eax == 0
		;invoke MessageBox,NULL,SADR("FAILED"),SADR("MultiByteToWideChar"),MB_OK
		jmp FindeCreateBstr
	.endif
	;---------------- save pointer in an array BSTR -----------------
	lea edx,bstr_array
	.LISTALL
	mov ecx,LENGTHOF bstr_array
	.NOLIST
	@@:
	.if dword ptr [edx] == 0
		mov [edx],eax
	.else
		dec ecx
		.if ecx != 0	;not the end of array
			add edx,4
			jmp @B
		.else
			;failed to save bstr pointer			
			;invoke MessageBox,NULL,SADR("BSTR array too small"),SADR("ERREUR"),MB_OK
			invoke SysFreeString,retour
			mov retour,0			
		.endif
	.endif
 FindeCreateBstr:
         mov eax,retour
         ret
CreateBstr endp

;################################################################
;use bstr_array in data
FreeBSTR PROC uses esi
			Local count:DWORD
			Local  retour:DWORD
         mov retour,1
	mov ecx,LENGTHOF bstr_array
	mov count,ecx
	lea esi,bstr_array
	@@:
	.if dword ptr [esi] != 0
		mov edx,dword ptr [esi]
		invoke SysFreeString,edx
		mov dword ptr [esi],0
		add esi,4
		dec count
		jnz @B
	.endif
 FindeFreeBSTR:
         mov eax,retour
         ret
FreeBSTR endp


;################################################################
InitVariant PROC uses esi  pvar:DWORD,  atype:DWORD,  value:DWORD 
			Local  retour:DWORD
         mov retour,0
	comment 
Before use, all VARIANTARGs must be initialized by VariantInit. 
For the types VT_UI1, VT_I2, VT_I4, VT_R4, VT_R8, VT_BOOL, VT_ERROR, VT_CY,
	VT_DECIMAL, and VT_DATE, data is stored within the VARIANT
	structure. Any pointers to the data become invalid when the 
	type of the variant is changed.
For VT_BYREF | any type, the memory pointed to by the variant is owned
	and freed by the caller of the function.
For VT_BSTR, there is only one owner for the string. All strings in variants
	must be allocated with the SysAllocString function. When releasing or 
	changing the type of a variant with the VT_BSTR type, SysFreeString is
	called on the contained string. 
For VT_ARRAY | any type, the rule is analogous to the rule for VT_BSTR.
	All arrays in variants must be allocated with SafeArrayCreate. When releasing
	or changing the type of a variant with the VT_ARRAY flag set, SafeArrayDestroy
	is called. 
For VT_DISPATCH and VT_UNKNOWN, the objects that are pointed to have reference
	counts that are incremented when they are placed in a variant. When releasing
	or changing the type of the variant, Release is called on the object that is 
	pointed to. 
	
	
	invoke VariantInit,pvar
	mov esi,pvar
	mov eax,atype
	mov [esi].VARIANT.n1.n2.vt,ax			;remplir type
	.if atype == VT_BSTR			;remplir valeur
		invoke CreateSingleBstr,value		;VariantClear
		.if eax != 0
			mov retour,1
			mov [esi].VARIANT.n1.n2.n3.bstrVal,eax
		.endif
	.elseif atype == VT_BOOL
		mov retour,1
		mov eax,value
		mov [esi].VARIANT.n1.n2.n3.boolVal,ax
	.elseif atype == VT_BYREF
		mov retour,1
		mov eax,value
		mov [esi].VARIANT.n1.n2.n3.byref,eax	
	.elseif atype == VT_I2 || atype == VT_I1
		mov retour,1
		mov eax,value
		mov [esi].VARIANT.n1.n2.n3.iVal,ax
	.elseif atype == VT_BYREF or VT_DECIMAL	
		mov retour,1
		mov eax,value
		mov [esi].VARIANT.n1.decVal.Hi32,eax	
	.endif
	
 FindeInitVariant:
         mov eax,retour
         ret
InitVariant endp

;################################################################


; #########################################################################
	 
